#include <iostream>
#include <string>
using namespace std;
template<class TPL> class BinaryNode {
	BinaryNode * bn_left;
	BinaryNode * bn_right;
	TPL bn_content;
public:
	BinaryNode(TPL content);
	virtual ~ BinaryNode();
	void insertContent(TPL content);
	bool searchContent(TPL content) const;
	void print(int depth) const;
};

template<class TPL> BinaryNode<TPL>::BinaryNode(TPL content) {
	bn_content = content;
	bn_left = NULL;
	bn_right = NULL;
}

template<class TPL> void BinaryNode<TPL>::insertContent(TPL content) {
	if (content == bn_content) {
		return;
	} // no duplicate
	if (content < bn_content) {
		if (bn_left == NULL) {
			BinaryNode<TPL> * newnode = new BinaryNode<TPL>(content);
			bn_left = newnode;
		} else {
			bn_left -> insertContent(content);
		}
	} else {
		if (bn_right == NULL) {
			BinaryNode<TPL> * newnode = new BinaryNode<TPL>(content);
			bn_right = newnode;
		} else {
			bn_right -> insertContent(content);
		}
	}
}

template<class TPL> void BinaryNode<TPL>::print(int depth) const {
	if (bn_left != NULL) {
		bn_left -> print(depth + 1);
	}
	for (int identcnt = 0; identcnt < depth; identcnt ++) {
		cout << "\t";
	}
	cout << bn_content << endl;
	if (bn_right != NULL) {
		bn_right -> print(depth + 1);
	}
}

template<class TPL> bool BinaryNode<TPL>::searchContent(TPL content) const {
	if (content == bn_content) {
		return true;
	}
	if (content < bn_content) {
		if (bn_left == NULL) {
			return false;
		}
		return bn_left -> searchContent(content);
	} else {
		if (bn_right == NULL) {
			return false;
		}
		return bn_right -> searchContent(content);
	}
}

template<class TPL> BinaryNode<TPL>::~BinaryNode() {
	if (bn_left != NULL) {
		delete bn_left;
	}
	if (bn_right != NULL) {
		delete bn_right;
	}
}

class Student {
	string s_name;
public:
	Student(string name) :
		s_name(name) {
	}
	Student(const Student & orig) :
		s_name(orig.s_name) {
	}
	Student() {
		s_name = "";
	}
	bool operator <(const Student & arg2) {
		return (s_name < arg2.s_name);
	}
	/*
	 Student & operator = (const Student & origin) 
	 { 
	 if (this != & origin) { s_name = origin.s_name; } 
	 return * this; 
	 } */

	bool operator ==(const Student & arg2) {
		if (s_name == arg2.s_name) {
			return true;
		} else {
			return false;
		}
	}
	friend ostream & operator <<(ostream& os, const Student & stu);
};

ostream & operator <<(ostream& os, const Student & stu) {
	os << stu.s_name<< endl;
	return os;
}

class User {
	int u_age;
public:
	User(int age) :
		u_age(age) {
	}
	User() :
		u_age(0) {
	}
	bool operator <(const User & arg2) {
		return (u_age < arg2.u_age);
	}
	bool operator ==(const User & arg2) {
		return (u_age == arg2.u_age);
	}
	friend ostream & operator <<(ostream& os, const User & usr);
};

ostream & operator <<(ostream& os, const User & usr) {
	os << usr.u_age<< endl;
	return os;
}

int main(void) {
	BinaryNode<int> bnint(5);
	bnint.insertContent(3);
	bnint.insertContent(6);
	bnint.insertContent(4);
	bnint.insertContent(7);
	bnint.insertContent('7');
	bnint.insertContent(2);
	bnint.insertContent(1);
	bnint.insertContent(10);
	bnint.insertContent(4);
	bnint.insertContent(6);
	bnint.insertContent(9);
	bnint.print(0);
	cout << "----------------------------------------------"<< endl;

	Student stu1("John");
	Student stu2("Mary");
	Student stu3("Tom");
	Student stu4("Amy");
	Student stu5("Ted");
	BinaryNode<Student> bnstu(stu1);
	bnstu.insertContent(stu2);
	bnstu.insertContent(stu3);
	bnstu.insertContent(stu4);
	bnstu.insertContent(stu5);
	bnstu.print(0);
	cout << "----------------------------------------------"<< endl;
	User usr1(21);
	User usr2(28);
	User usr3(19);
	User usr4(17);
	User usr5(22);
	User usr6(20);
	User usr7(18);
	BinaryNode<User> bnusr(usr1);
	bnusr.insertContent((User)3);
	bnusr.insertContent(usr2);
	bnusr.insertContent(usr3);
	bnusr.insertContent(usr4);
	bnusr.insertContent(usr5);
	bnusr.insertContent(usr6);
	bnusr.insertContent(usr7);
	bnusr.print(0);
	cout << "----------------------------------------------"<< endl;
	cout << bnint.searchContent(11) << " "<< bnint.searchContent(10) << endl;
	Student stu6("Ted");
	cout << bnstu.searchContent(stu6) << " "<< bnstu.searchContent(stu2)
			<< endl;
	cout << bnusr.searchContent(usr2) << " "<< bnusr.searchContent(usr4)
			<< endl;
	return 0;
}
